/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 2003-2012 by AG-Software 											 *
 * All Rights Reserved.																 *
 * Contact information for AG-Software is available at http://www.ag-software.de	 *
 *																					 *
 * Licence:																			 *
 * The agsXMPP SDK is released under a dual licence									 *
 * agsXMPP can be used under either of two licences									 *
 * 																					 *
 * A commercial licence which is probably the most appropriate for commercial 		 *
 * corporate use and closed source projects. 										 *
 *																					 *
 * The GNU Public License (GPL) is probably most appropriate for inclusion in		 *
 * other open source projects.														 *
 *																					 *
 * See README.html for details.														 *
 *																					 *
 * For general enquiries visit our website at:										 *
 * http://www.ag-software.de														 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

using System;

namespace agsXMPP.protocol.client
{
    public delegate void MessageHandler (object sender, Message msg);
    public delegate void PresenceHandler(object sender, Presence pres);
    public delegate void IqHandler      (object sender, IQEventArgs args);

    public class IQEventArgs : EventArgs
    {
        public IQ IQ { get; private set; }
        public bool Handled { get; set; }

        public IQEventArgs(IQ iq)
        {
            if (iq == null) {
                throw new ArgumentNullException("iq");
            }
            IQ = iq;
        }
    }
}
